gstreamermm: Gst::BaseTransform Class Reference

gstreamermm 1.0.10

- Main Page
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Static Public Attributes | Related Functions | List of all members
Gst::BaseTransform Class Reference
gstreamermm Base Classes

A base class for simple transform filters. More...

Inheritance diagram for Gst::BaseTransform:
[legend]
Collaboration diagram for Gst::BaseTransform:
[legend]

## Public Member Functions
virtual | ~BaseTransform ()
GstBaseTransform* | gobj ()
| Provides access to the underlying C GObject. More...
const GstBaseTransform* | gobj () const
| Provides access to the underlying C GObject. More...
GstBaseTransform* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | is_passthrough () const
| See if trans is configured as a passthrough transform. More...
void | set_passthrough (bool passthrough)
| Set passthrough mode for this filter by default. More...
bool | is_in_place () const
| See if trans is configured as a in_place transform. More...
void | set_in_place (bool in_place)
| Determines whether a non-writable buffer will be copied before passing to the transform_ip function. More...
bool | is_qos_enabled () const
| Queries if the transform will handle QoS. More...
void | set_qos_enabled (bool enabled)
| Enable or disable QoS handling in the transform. More...
void | update_qos (double proportion, ClockTimeDiff diff, ClockTime timestamp)
| Set the QoS parameters in the transform. More...
void | set_gap_aware (bool gap_aware)
| If gap_aware is `false` (the default), output buffers will have the Gst::BUFFER_FLAG_GAP flag unset. More...
Glib::RefPtr< Gst::Pad > | get_sink_pad ()
| Gives the refptr to the sink Gst::Pad object of the element. More...
Glib::RefPtr< const Gst::Pad > | get_sink_pad () const
Glib::RefPtr< Gst::Pad > | get_src_pad ()
| Gives the refptr to the source Gst::Pad object of the element. More...
Glib::RefPtr< const Gst::Pad > | get_src_pad () const
Glib::PropertyProxy< bool > | property_qos ()
| Handle Quality-of-Service events. More...
Glib::PropertyProxy_ReadOnly < bool > | property_qos () const
| Handle Quality-of-Service events. More...
virtual Glib::RefPtr< Gst::Caps > | transform_caps_vfunc (PadDirection direction, const Glib::RefPtr< Gst::Caps >& caps, const Glib::RefPtr< Gst::Caps >& filter)
| Optional. More...
virtual Glib::RefPtr< Gst::Caps > | fixate_caps_vfunc (PadDirection direction, const Glib::RefPtr< Gst::Caps >& caps, const Glib::RefPtr< Gst::Caps >& othercaps)
| Optional. More...
virtual bool | get_unit_size_vfunc (const Glib::RefPtr< Gst::Caps >& caps, gsize&size) const
| Optional. More...
virtual bool | set_caps_vfunc (const Glib::RefPtr< Gst::Caps >& incaps, const Glib::RefPtr< Gst::Caps >& outcaps)
| Allows the subclass to be notified of the actual caps set. More...
virtual FlowReturn | transform_vfunc (const Glib::RefPtr< Gst::Buffer >& inbuf, const Glib::RefPtr< Gst::Buffer >& outbuf)
| Required if the element does not operate in-place. More...
virtual FlowReturn | transform_ip_vfunc (const Glib::RefPtr< Gst::Buffer >& buf)
| Required if the element operates in-place. More...
virtual FlowReturn | prepare_output_buffer_vfunc (const Glib::RefPtr< Gst::Buffer >& input, Glib::RefPtr< Gst::Buffer >& buffer)
| Optional. More...
virtual bool | src_event_vfunc (const Glib::RefPtr< Gst::Event >& event)
| Optional. More...
virtual void | before_transform_vfunc (const Glib::RefPtr< Gst::Buffer >& buffer)
| Optional. More...
virtual bool | accept_caps_vfunc (PadDirection direction, const Glib::RefPtr< const Gst::Caps >& caps)
| Optional. More...
virtual bool | start_vfunc ()
| Optional. More...
virtual bool | stop_vfunc ()
| Optional. More...
Public Member Functions inherited from Gst::Element
virtual | ~Element ()
GstElement* | gobj ()
| Provides access to the underlying C GObject. More...
const GstElement* | gobj () const
| Provides access to the underlying C GObject. More...
GstElement* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Gst::Element > | link (const Glib::RefPtr< Gst::Element >& dest)
| Links this source element to the element. More...
bool | add_pad (const Glib::RefPtr< Gst::Pad >& pad)
| Adds a pad (link point) to element. More...
void | create_all_pads ()
| Creates a pad for each pad template that is always available. More...
Glib::RefPtr< Gst::Pad > | create_compatible_pad (const Glib::RefPtr< const Gst::Pad >& pad, const Glib::RefPtr< const Gst::Caps >& caps)
| Looks for an unlinked pad to which the given pad can link. More...
Glib::RefPtr< Gst::PadTemplate > | get_compatible_pad_template (const Glib::RefPtr< const Gst::PadTemplate >& compattempl)
| Retrieves a pad template from element that is compatible with compattempl. More...
Glib::RefPtr< const Gst::PadTemplate > | get_compatible_pad_template (const Glib::RefPtr< const Gst::PadTemplate >& compattempl) const
| Retrieves a pad template from element that is compatible with compattempl. More...
Glib::RefPtr< Gst::Pad > | get_request_pad (const Glib::ustring& name)
| Retrieves a pad from the element by name (e.g. "src_\\%d"). More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ, const Glib::ustring& name, const Glib::RefPtr< const Gst::Caps >& caps)
| Retrieves a request pad from the element according to the provided template. More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ, const Glib::ustring& name)
| A request_pad() convenience overload. More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ, const Glib::RefPtr< const Gst::Caps >& caps)
| A request_pad() convenience overload. More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ)
| A request_pad() convenience overload. More...
Glib::RefPtr< Gst::Pad > | get_static_pad (const Glib::ustring& name)
| Retrieves a pad from element by name. More...
Glib::RefPtr< const Gst::Pad > | get_static_pad (const Glib::ustring& name) const
| Retrieves a pad from element by name. More...
void | no_more_pads ()
| Use this function to signal that the element does not expect any more pads to show up in the current pipeline. More...
void | release_request_pad (const Glib::RefPtr< Gst::Pad >& pad)
| Makes the element free the previously requested pad as obtained with get_request_pad(). More...
bool | remove_pad (const Glib::RefPtr< Gst::Pad >& pad)
| Removes pad from element. More...
Gst::Iterator< Gst::Pad > | iterate_pads ()
| Retrieves an iterator of element's pads. More...
Gst::Iterator< const Gst::Pad > | iterate_pads () const
| Retrieves an iterator of element's pads. More...
Gst::Iterator< Gst::Pad > | iterate_sink_pads ()
| Retrieves an iterator of element's sink pads. More...
Gst::Iterator< const Gst::Pad > | iterate_sink_pads () const
| Retrieves an iterator of element's sink pads. More...
Gst::Iterator< Gst::Pad > | iterate_src_pads ()
| Retrieves an iterator of element's source pads. More...
Gst::Iterator< const Gst::Pad > | iterate_src_pads () const
| Retrieves an iterator of element's source pads. More...
void | unlink (const Glib::RefPtr< Gst::Element >& dest)
| Unlinks all source pads of the source element with all sink pads of the sink element to which they are linked. More...
bool | link_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname)
| Links the two named pads of the source and destination elements. More...
void | unlink_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname)
| Unlinks the two named pads of the source and destination elements. More...
bool | link_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname, const Glib::RefPtr< Gst::Caps >& filter)
| Links the two named pads of the source and destination elements. More...
bool | link_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname, PadLinkCheck flags)
| Links the two named pads of the source and destination elements. More...
Glib::RefPtr< Gst::Element > | link (const Glib::RefPtr< Gst::Element >& dest, const Glib::RefPtr< Gst::Caps >& filter)
| Links src to dest using the given caps as filtercaps. More...
void | set_base_time (ClockTime time)
| Set the base time of an element. More...
ClockTime | get_base_time () const
| Returns the base time of the element. More...
void | set_start_time (Gst::ClockTime time)
| Set the start time of an element. More...
Gst::ClockTime | get_start_time () const
| Returns the start time of the element. More...
void | set_bus (const Glib::RefPtr< Gst::Bus >& bus)
| Sets the bus of the element. More...
Glib::RefPtr< Gst::Bus > | get_bus ()
| Returns the bus of the element. More...
Glib::RefPtr< const Gst::Bus > | get_bus () const
| Returns the bus of the element. More...
Glib::RefPtr< Gst::ElementFactory > | get_factory ()
| Retrieves the factory that was used to create this element. More...
Glib::RefPtr< const Gst::ElementFactory > | get_factory () const
| Retrieves the factory that was used to create this element. More...
bool | set_clock (const Glib::RefPtr< Gst::Clock >& clock)
| Sets the clock for the element. More...
Glib::RefPtr< Gst::Clock > | get_clock ()
| Gets the currently configured clock of the element. More...
Glib::RefPtr< const Gst::Clock > | get_clock () const
| Gets the currently configured clock of the element. More...
Glib::RefPtr< Gst::Clock > | provide_clock ()
| Get the clock provided by the given element. More...
Glib::RefPtr< const Gst::Clock > | provide_clock () const
| Get the clock provided by the given element. More...
StateChangeReturn | set_state (State state)
| Sets the state of the element. More...
StateChangeReturn | get_state (State& state, State& pending, ClockTime timeout) const
| Gets the state of the element. More...
bool | set_locked_state (gboolean locked_state)
| Locks the state of an element, so state changes of the parent don't affect this element anymore. More...
bool | is_locked_state () const
| Checks if the state of an element is locked. More...
void | abort_state ()
| Abort the state change of the element. More...
StateChangeReturn | continue_state (StateChangeReturn ret)
| Commit the state change of the element and proceed to the next pending state if any. More...
void | lost_state ()
| Brings the element to the lost state. More...
bool | sync_state_with_parent ()
| Tries to change the state of the element to the same as its parent. More...
StateChangeReturn | change_state (StateChange transition)
| Perform transition on element. More...
void | post_message (int code, int line, MessageType type=Gst::MESSAGE_INFO, const Glib::QueryQuark& domain=get_core_error_quark(), const Glib::ustring& text=Glib::ustring(), const Glib::ustring& debug=Glib::ustring(), const Glib::ustring& file=Glib::ustring(), const Glib::ustring& function=Glib::ustring())
| Post an error, warning or info message on the bus from inside an element. More...
bool | post_message (const Glib::RefPtr< Gst::Message >& message)
| Post a message on the element's Gst::Bus. More...
bool | query (const Glib::RefPtr< Gst::Query >& query) const
| Performs a query on the given element. More...
bool | query_convert (Gst::Format src_format, gint64 src_val, Format dest_format, gint64& dest_val) const
| Queries an element to convert src_val in src_format to dest_format. More...
bool | query_position (Gst::Format format, gint64& cur) const
| Queries an element for the stream position. More...
bool | query_position (Gst::Format format) const
| Queries an element for the stream position. More...
bool | query_duration (Gst::Format format, gint64& duration) const
| Queries an element for the total stream duration. More...
bool | query_duration (Gst::Format format) const
| Queries an element for the total stream duration. More...
bool | seek (Format format, SeekFlags seek_flags, gint64 seek_pos)
| Simple API to perform a seek on the given element, meaning it just seeks to the given position relative to the start of the stream. More...
bool | seek (double rate, Format format, SeekFlags flags, SeekType cur_type, gint64 cur, SeekType stop_type, gint64 stop)
| Sends a seek event to an element. More...
bool | send_event (const Glib::RefPtr< Gst::Event >& event)
| Sends an event to an element. More...
Glib::SignalProxy0< void > | signal_no_more_pads ()
Glib::SignalProxy1< void, const Glib::RefPtr< Gst::Pad >& > | signal_pad_added ()
Glib::SignalProxy1< void, const Glib::RefPtr< Gst::Pad >& > | signal_pad_removed ()
virtual void | release_pad_vfunc (const Glib::RefPtr< Gst::Pad >& pad)
| Called when a request pad is to be released. More...
virtual Glib::RefPtr< Gst::Pad > | request_new_pad_vfunc (Glib::RefPtr< Gst::PadTemplate > templ, const Glib::ustring& name, const Glib::RefPtr< const Gst::Caps >& caps)
| Called when a new pad is requested. More...
virtual StateChangeReturn | get_state_vfunc (State& state, State& pending, ClockTime timeout) const
| Get the state of the element. More...
virtual StateChangeReturn | set_state_vfunc (State state)
| Set a new state on the element. More...
virtual StateChangeReturn | change_state_vfunc (StateChange transition)
| Called by set_state to perform an incremental state change. More...
virtual void | set_bus_vfunc (const Glib::RefPtr< Gst::Bus >& bus)
| Set a Gst::Bus on the element. More...
virtual Glib::RefPtr< Gst::Clock > | provide_clock_vfunc ()
| Gets the Gst::Clock provided by the element. More...
virtual bool | set_clock_vfunc (const Glib::RefPtr< Gst::Clock >& clock)
| Set the Gst::Clock on the element. More...
virtual bool | send_event_vfunc (const Glib::RefPtr< Gst::Event >& event)
| Send a Gst::Event to the element. More...
virtual bool | query_vfunc (const Glib::RefPtr< Gst::Query >&query) const
| Perform a Gst::Query on the element. More...
Glib::RefPtr< Gst::PadTemplate > | get_pad_template (const Glib::ustring& factory_name) const
template<typename T >
Glib::RefPtr< Gst::Element > | property (const Glib::ustring& name, const T& value)
| Sets specified property. More...
Public Member Functions inherited from Gst::Object
virtual | ~Object ()
GstObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GstObject* | gobj () const
| Provides access to the underlying C GObject. More...
GstObject* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | is_element () const
bool | is_element_factory () const
bool | is_pad () const
bool | is_pad_template () const
bool | is_bin () const
guint32 | get_flags () const
| Returns the entire set of flags for the object. More...
bool | set_name (const Glib::ustring& name)
| Sets the name of object, or gives object a guaranteed unique name (if name is `0`). More...
Glib::ustring | get_name () const
| Returns a copy of the name of object. More...
bool | set_parent (const Glib::RefPtr< Gst::Object >& parent)
| Sets the parent of object to parent. More...
Glib::RefPtr< Gst::Object > | get_parent ()
| Returns the parent of object. More...
Glib::RefPtr< const Gst::Object > | get_parent () const
| Returns the parent of object. More...
void | unparent ()
| Clear the parent of object, removing the associated reference. More...
bool | has_ancestor (const Glib::RefPtr< const Gst::Object >& ancestor) const
| Check if object has an ancestor ancestor somewhere up in the hierarchy. More...
Glib::ustring | get_path_string ()
| Generates a string describing the path of object in the object hierarchy. More...
Glib::PropertyProxy < Glib::ustring > | property_name ()
| The name of the object. More...
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_name () const
| The name of the object. More...
Glib::SignalProxy2< void, const Glib::RefPtr< Object > &, GParamSpec* > | signal_deep_notify ()

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gst::Element
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gst::Object
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static bool | check_uniqueness (const Glib::ListHandle< const Gst::Object >& list, const Glib::ustring& name)
| Checks to see if there is any object named name in list. More...

## Static Public Attributes
static const Glib::ustring | SINK_NAME
| The name of the templates for the sink pad ("sink"). More...
static const Glib::ustring | SRC_NAME
| The name of the templates for the source pad ("src"). More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gst::BaseTransform > | wrap (GstBaseTransform* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::Element
Glib::RefPtr< Gst::Element > | wrap (GstElement* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::Object
Glib::RefPtr< Gst::Object > | wrap (GstObject* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Protected Member Functions inherited from Gst::Element
virtual void | on_no_more_pads ()
| This is a default handler for the signal signal_no_more_pads(). More...
virtual void | on_pad_added (const Glib::RefPtr< Gst::Pad >& new_pad)
| This is a default handler for the signal signal_pad_added(). More...
virtual void | on_pad_removed (const Glib::RefPtr< Gst::Pad >& old_pad)
| This is a default handler for the signal signal_pad_removed(). More...
Protected Member Functions inherited from Gst::Object
virtual void | on_deep_notify (const Glib::RefPtr< Object >& prop_object, GParamSpec* prop)
| This is a default handler for the signal signal_deep_notify(). More...

## Detailed Description

A base class for simple transform filters.

This base class is for filter elements that process data.

It provides for:

- one sinkpad and one srcpad
- Possible formats on sink and source pad implemented with custom transform_caps_vfunc() function. By default uses same format on sink and source.
- Handles state changes.
- Does flushing.
- Push mode.
- Pull mode if the sub-class transform_vfunc() can operate on arbitrary data.

### Use Cases:

- 1. Passthrough mode
  - Element has no interest in modifying the buffer. It may want to inspect it, in which case the element should have a transform_ip_vfunc() function. If there is no transform_ip_vfunc() function in passthrough mode, the buffer is pushed intact.
  - On the GstBaseTransformClass is the passthrough_on_same_caps variable which will automatically set/unset passthrough based on whether the element negotiates the same caps on both pads.
  - passthrough_on_same_caps on an element that doesn't implement a transform_caps_vfunc() function is useful for elements that only inspect data (such as level).
  Example elements
  - Level
  - VideoScale, AudioConvert, FfmpegColorSpace, AudioResample in certain modes.

- 2. Modifications in-place - input buffer and output buffer are the same thing.
  - The element must implement a transform_ip_vfunc() function.
  - Output buffer size must <= input buffer size.
  - If the always_in_place flag is set, non-writable buffers will be copied and passed to the transform_ip_vfunc() function, otherwise a new buffer will be created and the transform_vfunc() function called.
  - Incoming writable buffers will be passed to the transform_ip_vfunc() function immediately.
  - only implementing transform_ip_vfunc() and not transform_vfunc() implies always_in_place = TRUE.
  Example elements
  - Volume.
  - AudioConvert in certain modes (signed/unsigned conversion).
  - FfmpegColorSpace in certain modes (endianness swapping).
- 3. Modifications only to the caps/metadata of a buffer
  - The element does not require writable data, but non-writable buffers should be subbuffered so that the meta-information can be replaced.
  - Elements wishing to operate in this mode should replace the prepare_output_buffer_vfunc() method to create subbuffers of the input buffer and set always_in_place to TRUE.
  Example elements
  - CapsFilter when setting caps on outgoing buffers that have none.
  - Identity when it is going to re-timestamp buffers by datarate.
- 4. Normal mode
  - always_in_place flag is not set, or there is no transform_ip_vfunc() function.
  - Element will receive an input buffer and output buffer to operate on.
  - Output buffer is allocated by calling the prepare_output_buffer_vfunc() function.
  Example elements
  - VideoScale, FfmpegColorSpace, AudioConvert when doing scaling/conversions.
- 5. Special output buffer allocations
  - Elements which need to do special allocation of their output buffers other than what Gst::Pad::alloc_buffer() allows should implement a prepare_output_buffer_vfunc() method, which calls the parent implementation and passes the newly allocated buffer.
  Example elements
  - Efence.

Sub-class settable flags on Gst::BaseTransform

    - <B>passthrough</B>
          - Implies that in the current configuration, the sub-class is not
          interested in modifying the buffers.
          - Elements which are always in passthrough mode whenever the same
          caps has been negotiated on both pads can set the class variable
          passthrough_on_same_caps to have this behaviour automatically.
          .
    - <B>always_in_place</B>
          - Determines whether a non-writable buffer will be copied before
          passing to the transform_ip function.
          - Implied TRUE if no transform function is implemented.
          - Implied FALSE if ONLY transform function is implemented.

## Constructor & Destructor Documentation

virtual Gst::BaseTransform::~BaseTransform | ( |  | ) |
| virtual

## Member Function Documentation

virtual bool Gst::BaseTransform::accept_caps_vfunc | ( | PadDirection | direction,
|  | const Glib::RefPtr< const Gst::Caps >& | caps
| ) |  |
| virtual

Optional.

Since 0.10.30 Subclasses can override this method to check if the caps can be handled by the element. The default implementation might not be the most optimal way to check this in all cases.

virtual void Gst::BaseTransform::before_transform_vfunc | ( | const Glib::RefPtr< Gst::Buffer >& | buffer | ) |
| virtual

Optional.

Since 0.10.22 This method is called right before the base class will start processing. Dynamic properties or other delayed configuration could be performed in this method.

virtual Glib::RefPtr<Gst::Caps> Gst::BaseTransform::fixate_caps_vfunc | ( | PadDirection | direction,
|  | const Glib::RefPtr< Gst::Caps >& | caps,
|  | const Glib::RefPtr< Gst::Caps >& | othercaps
| ) |  |
| virtual

Optional.

Given the pad in this direction and the given caps, fixate the caps on the other pad.

Glib::RefPtr<Gst::Pad> Gst::BaseTransform::get_sink_pad | ( |  | ) |

Gives the refptr to the sink Gst::Pad object of the element.

Glib::RefPtr<const Gst::Pad> Gst::BaseTransform::get_sink_pad | ( |  | ) | const

Glib::RefPtr<Gst::Pad> Gst::BaseTransform::get_src_pad | ( |  | ) |

Gives the refptr to the source Gst::Pad object of the element.

Glib::RefPtr<const Gst::Pad> Gst::BaseTransform::get_src_pad | ( |  | ) | const

static GType Gst::BaseTransform::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

virtual bool Gst::BaseTransform::get_unit_size_vfunc | ( | const Glib::RefPtr< Gst::Caps >& | caps,
|  | gsize & | size
| ) |  | const
| virtual

Optional.

Given the size of a buffer in the given direction with the given caps, calculate the size in bytes of a buffer on the other pad with the given other caps. The default implementation uses get_unit_size_vfunc() and keeps the number of units the same. Required if the transform is not in-place. Get the size in bytes of one unit for the given caps.

GstBaseTransform* Gst::BaseTransform::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GstBaseTransform* Gst::BaseTransform::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GstBaseTransform* Gst::BaseTransform::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gst::BaseTransform::is_in_place | ( |  | ) | const

See if trans is configured as a in_place transform.

Returns
  `true` is the transform is configured in in_place mode.

MT safe.

bool Gst::BaseTransform::is_passthrough | ( |  | ) | const

See if trans is configured as a passthrough transform.

Returns
  `true` is the transform is configured in passthrough mode.

MT safe.

bool Gst::BaseTransform::is_qos_enabled | ( |  | ) | const

Queries if the transform will handle QoS.

Returns
  `true` if QoS is enabled.

MT safe.

virtual FlowReturn Gst::BaseTransform::prepare_output_buffer_vfunc | ( | const Glib::RefPtr< Gst::Buffer >& | input,
|  | Glib::RefPtr< Gst::Buffer >& | buffer
| ) |  |
| virtual

Optional.

Subclasses can override this to do their own allocation of output buffers. Elements that only do analysis can return a subbuffer or even just increment the reference to the input buffer (if in passthrough mode).

Glib::PropertyProxy< bool > Gst::BaseTransform::property_qos | ( |  | ) |

Handle Quality-of-Service events.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gst::BaseTransform::property_qos | ( |  | ) | const

Handle Quality-of-Service events.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

virtual bool Gst::BaseTransform::set_caps_vfunc | ( | const Glib::RefPtr< Gst::Caps >& | incaps,
|  | const Glib::RefPtr< Gst::Caps >& | outcaps
| ) |  |
| virtual

Allows the subclass to be notified of the actual caps set.

void Gst::BaseTransform::set_gap_aware | ( | bool | gap_aware | ) |

If gap_aware is `false` (the default), output buffers will have the Gst::BUFFER_FLAG_GAP flag unset.

If set to `true`, the element must handle output buffers with this flag set correctly, i.e. it can assume that the buffer contains neutral data but must unset the flag if the output is no neutral data.

MT safe.

Parameters

  gap_aware | New state.

void Gst::BaseTransform::set_in_place | ( | bool | in_place | ) |

Determines whether a non-writable buffer will be copied before passing to the transform_ip function.

- Always `true` if no transform function is implemented.
- Always `false` if ONLY transform function is implemented.

MT safe.

Parameters

  in_place | Boolean value indicating that we would like to operate on in_place buffers.

void Gst::BaseTransform::set_passthrough | ( | bool | passthrough | ) |

Set passthrough mode for this filter by default.

This is mostly useful for filters that do not care about negotiation.

Always `true` for filters which don't implement either a transform or transform_ip method.

MT safe.

Parameters

  passthrough | Boolean indicating passthrough mode.

void Gst::BaseTransform::set_qos_enabled | ( | bool | enabled | ) |

Enable or disable QoS handling in the transform.

MT safe.

Parameters

  enabled | New state.

virtual bool Gst::BaseTransform::src_event_vfunc | ( | const Glib::RefPtr< Gst::Event >& | event | ) |
| virtual

Optional.

Event handler on the source pad.

virtual bool Gst::BaseTransform::start_vfunc | ( |  | ) |
| virtual

Optional.

Called when the element starts processing. Allows opening external resources.

virtual bool Gst::BaseTransform::stop_vfunc | ( |  | ) |
| virtual

Optional.

Called when the element starts processing. Allows opening external resources.

virtual Glib::RefPtr<Gst::Caps> Gst::BaseTransform::transform_caps_vfunc | ( | PadDirection | direction,
|  | const Glib::RefPtr< Gst::Caps >& | caps,
|  | const Glib::RefPtr< Gst::Caps >& | filter
| ) |  |
| virtual

Optional.

Given the pad in this direction and the given caps, what caps are allowed on the other pad in this element ?

virtual FlowReturn Gst::BaseTransform::transform_ip_vfunc | ( | const Glib::RefPtr< Gst::Buffer >& | buf | ) |
| virtual

Required if the element operates in-place.

Transform the incoming buffer in-place.

virtual FlowReturn Gst::BaseTransform::transform_vfunc | ( | const Glib::RefPtr< Gst::Buffer >& | inbuf,
|  | const Glib::RefPtr< Gst::Buffer >& | outbuf
| ) |  |
| virtual

Required if the element does not operate in-place.

Transforms one incoming buffer to one outgoing buffer. The function is allowed to change size/timestamp/duration of the outgoing buffer.

void Gst::BaseTransform::update_qos | ( | double | proportion,
|  | ClockTimeDiff | diff,
|  | ClockTime | timestamp
| ) |  |

Set the QoS parameters in the transform.

This function is called internally when a QOS event is received but subclasses can provide custom information when needed.

MT safe.

Parameters

  proportion | The proportion.
  diff | The diff against the clock.
  timestamp | The timestamp of the buffer generating the QoS expressed in running_time.

## Friends And Related Function Documentation

Glib::RefPtr< Gst::BaseTransform > wrap | ( | GstBaseTransform * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

## Member Data Documentation

const Glib::ustring Gst::BaseTransform::SINK_NAME
| static

The name of the templates for the sink pad ("sink").

const Glib::ustring Gst::BaseTransform::SRC_NAME
| static

The name of the templates for the source pad ("src").

The documentation for this class was generated from the following file:

- gstreamermm/basetransform.h